/*
CVE Services API

The CVE Services API supports automation tooling for the CVE Program. Credentials are     required for most service endpoints. Representatives of     <a href='https://www.cve.org/ProgramOrganization/CNAs'>CVE Numbering Authorities (CNAs)</a> should     use one of the methods below to obtain credentials:    <ul><li>If your organization already has an Organizational Administrator (OA) account for the CVE     Services, ask your admin for credentials</li>     <li>Contact your Root (<a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/Google'>Google</a>,     <a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/INCIBE'>INCIBE</a>,     <a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/jpcert'>JPCERT/CC</a>, or     <a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/redhat'>Red Hat</a>) or     Top-Level Root (<a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/icscert'>CISA ICS</a>     or <a href='https://www.cve.org/PartnerInformation/ListofPartners/partner/mitre'>MITRE</a>) to request credentials     </ul>     <p>CVE data is to be in the JSON 5.0 CVE Record format. Details of the JSON 5.0 schema are     located <a href='https://github.com/CVEProject/cve-schema/tree/master/schema/v5.0' target='_blank'>here</a>.</p>    <a href='https://cveform.mitre.org/' class='link' target='_blank'>Contact the CVE Services team</a>

API version: 2.1.4
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package cveapi

import (
	"encoding/json"
)

// checks if the UpdateFullCveRecordResponseUpdatedContainersCnaReferencesInner type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &UpdateFullCveRecordResponseUpdatedContainersCnaReferencesInner{}

// UpdateFullCveRecordResponseUpdatedContainersCnaReferencesInner struct for UpdateFullCveRecordResponseUpdatedContainersCnaReferencesInner
type UpdateFullCveRecordResponseUpdatedContainersCnaReferencesInner struct {
	Name *string `json:"name,omitempty"`
	Refsource *string `json:"refsource,omitempty"`
	Url *string `json:"url,omitempty"`
}

// NewUpdateFullCveRecordResponseUpdatedContainersCnaReferencesInner instantiates a new UpdateFullCveRecordResponseUpdatedContainersCnaReferencesInner object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewUpdateFullCveRecordResponseUpdatedContainersCnaReferencesInner() *UpdateFullCveRecordResponseUpdatedContainersCnaReferencesInner {
	this := UpdateFullCveRecordResponseUpdatedContainersCnaReferencesInner{}
	return &this
}

// NewUpdateFullCveRecordResponseUpdatedContainersCnaReferencesInnerWithDefaults instantiates a new UpdateFullCveRecordResponseUpdatedContainersCnaReferencesInner object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewUpdateFullCveRecordResponseUpdatedContainersCnaReferencesInnerWithDefaults() *UpdateFullCveRecordResponseUpdatedContainersCnaReferencesInner {
	this := UpdateFullCveRecordResponseUpdatedContainersCnaReferencesInner{}
	return &this
}

// GetName returns the Name field value if set, zero value otherwise.
func (o *UpdateFullCveRecordResponseUpdatedContainersCnaReferencesInner) GetName() string {
	if o == nil || IsNil(o.Name) {
		var ret string
		return ret
	}
	return *o.Name
}

// GetNameOk returns a tuple with the Name field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *UpdateFullCveRecordResponseUpdatedContainersCnaReferencesInner) GetNameOk() (*string, bool) {
	if o == nil || IsNil(o.Name) {
		return nil, false
	}
	return o.Name, true
}

// HasName returns a boolean if a field has been set.
func (o *UpdateFullCveRecordResponseUpdatedContainersCnaReferencesInner) HasName() bool {
	if o != nil && !IsNil(o.Name) {
		return true
	}

	return false
}

// SetName gets a reference to the given string and assigns it to the Name field.
func (o *UpdateFullCveRecordResponseUpdatedContainersCnaReferencesInner) SetName(v string) {
	o.Name = &v
}

// GetRefsource returns the Refsource field value if set, zero value otherwise.
func (o *UpdateFullCveRecordResponseUpdatedContainersCnaReferencesInner) GetRefsource() string {
	if o == nil || IsNil(o.Refsource) {
		var ret string
		return ret
	}
	return *o.Refsource
}

// GetRefsourceOk returns a tuple with the Refsource field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *UpdateFullCveRecordResponseUpdatedContainersCnaReferencesInner) GetRefsourceOk() (*string, bool) {
	if o == nil || IsNil(o.Refsource) {
		return nil, false
	}
	return o.Refsource, true
}

// HasRefsource returns a boolean if a field has been set.
func (o *UpdateFullCveRecordResponseUpdatedContainersCnaReferencesInner) HasRefsource() bool {
	if o != nil && !IsNil(o.Refsource) {
		return true
	}

	return false
}

// SetRefsource gets a reference to the given string and assigns it to the Refsource field.
func (o *UpdateFullCveRecordResponseUpdatedContainersCnaReferencesInner) SetRefsource(v string) {
	o.Refsource = &v
}

// GetUrl returns the Url field value if set, zero value otherwise.
func (o *UpdateFullCveRecordResponseUpdatedContainersCnaReferencesInner) GetUrl() string {
	if o == nil || IsNil(o.Url) {
		var ret string
		return ret
	}
	return *o.Url
}

// GetUrlOk returns a tuple with the Url field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *UpdateFullCveRecordResponseUpdatedContainersCnaReferencesInner) GetUrlOk() (*string, bool) {
	if o == nil || IsNil(o.Url) {
		return nil, false
	}
	return o.Url, true
}

// HasUrl returns a boolean if a field has been set.
func (o *UpdateFullCveRecordResponseUpdatedContainersCnaReferencesInner) HasUrl() bool {
	if o != nil && !IsNil(o.Url) {
		return true
	}

	return false
}

// SetUrl gets a reference to the given string and assigns it to the Url field.
func (o *UpdateFullCveRecordResponseUpdatedContainersCnaReferencesInner) SetUrl(v string) {
	o.Url = &v
}

func (o UpdateFullCveRecordResponseUpdatedContainersCnaReferencesInner) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o UpdateFullCveRecordResponseUpdatedContainersCnaReferencesInner) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Name) {
		toSerialize["name"] = o.Name
	}
	if !IsNil(o.Refsource) {
		toSerialize["refsource"] = o.Refsource
	}
	if !IsNil(o.Url) {
		toSerialize["url"] = o.Url
	}
	return toSerialize, nil
}

type NullableUpdateFullCveRecordResponseUpdatedContainersCnaReferencesInner struct {
	value *UpdateFullCveRecordResponseUpdatedContainersCnaReferencesInner
	isSet bool
}

func (v NullableUpdateFullCveRecordResponseUpdatedContainersCnaReferencesInner) Get() *UpdateFullCveRecordResponseUpdatedContainersCnaReferencesInner {
	return v.value
}

func (v *NullableUpdateFullCveRecordResponseUpdatedContainersCnaReferencesInner) Set(val *UpdateFullCveRecordResponseUpdatedContainersCnaReferencesInner) {
	v.value = val
	v.isSet = true
}

func (v NullableUpdateFullCveRecordResponseUpdatedContainersCnaReferencesInner) IsSet() bool {
	return v.isSet
}

func (v *NullableUpdateFullCveRecordResponseUpdatedContainersCnaReferencesInner) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableUpdateFullCveRecordResponseUpdatedContainersCnaReferencesInner(val *UpdateFullCveRecordResponseUpdatedContainersCnaReferencesInner) *NullableUpdateFullCveRecordResponseUpdatedContainersCnaReferencesInner {
	return &NullableUpdateFullCveRecordResponseUpdatedContainersCnaReferencesInner{value: val, isSet: true}
}

func (v NullableUpdateFullCveRecordResponseUpdatedContainersCnaReferencesInner) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableUpdateFullCveRecordResponseUpdatedContainersCnaReferencesInner) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


